/*
 * Copyright (c) 1997  Motoyuki Kasahara
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef EB_APPENDIX_H
#define EB_APPENDIX_H

#ifdef __cplusplus
extern "C" {
#endif

#ifdef EB_BUILD_LIBRARY
#include "eb.h"
#else
#include <eb/eb.h>
#endif

/*
 * Function definitions.
 */
#ifdef __STDC__
/* appendix.c */
void eb_initialize_appendix(EB_Appendix *);
void eb_clear_appendix(EB_Appendix *);
void eb_suspend_appendix(EB_Appendix *);
int eb_bind_appendix(EB_Appendix *, const char *);
int eb_initialize_appendix_subbook(EB_Appendix *);
int eb_initialize_all_appendix_subbooks(EB_Appendix *);
int eb_is_appendix_bound(EB_Appendix *);
const char *eb_appendix_path(EB_Appendix *);
int eb_appendix_subbook_count(EB_Appendix *);
int eb_appendix_subbook_list(EB_Appendix *, EB_Subbook_Code *);
EB_Subbook_Code eb_appendix_subbook(EB_Appendix *);
const char *eb_appendix_subbook_directory(EB_Appendix *);
const char *eb_appendix_subbook_directory2(EB_Appendix *, EB_Subbook_Code);
int eb_set_appendix_subbook(EB_Appendix *, EB_Subbook_Code);
void eb_unset_appendix_subbook(EB_Appendix *);
/* narwalt.c */
int eb_have_narrow_alternation(EB_Appendix *);
int eb_narrow_alternation_start(EB_Appendix *);
int eb_narrow_alternation_end(EB_Appendix *);
int eb_narrow_character_text(EB_Appendix *, int, char *);
int eb_next_narrow_appendix_character(EB_Appendix *, int, int);
int eb_previous_narrow_appendix_character(EB_Appendix *, int, int);
/* stopcode.c */
int eb_have_stopcode(EB_Appendix *);
int eb_stopcode(EB_Appendix *);
/* widealt.c */
int eb_have_wide_alternation(EB_Appendix *);
int eb_wide_alternation_start(EB_Appendix *);
int eb_wide_alternation_end(EB_Appendix *);
int eb_wide_character_text(EB_Appendix *, int, char *);
int eb_next_wide_appendix_character(EB_Appendix *, int, int);
int eb_previous_wide_appendix_character(EB_Appendix *, int, int);

#else /* not __STDC__ */

/* appendix.c */
void eb_initialize_appendix();
void eb_clear_appendix();
void eb_suspend_appendix();
int eb_bind_appendix();
int eb_initialize_appendix_subbook();
int eb_initialize_all_appendix_subbooks();
int eb_is_appendix_bound();
const char *eb_appendix_path();
int eb_appendix_subbook_count();
int eb_appendix_subbook_list();
EB_Subbook_Code eb_appendix_subbook();
const char *eb_appendix_subbook_directory();
const char *eb_appendix_subbook_directory2();
int eb_set_appendix_subbook();
void eb_unset_appendix_subbook();
/* narwalt.c */
int eb_have_narrow_alternation();
int eb_narrow_alternation_start();
int eb_narrow_alternation_end();
int eb_narrow_character_text();
int eb_next_narrow_appendix_character();
int eb_previous_narrow_appendix_character();
/* stopcode.c */
int eb_have_stopcode();
int eb_stopcode();
/* widealt.c */
int eb_have_wide_alternation();
int eb_wide_alternation_start();
int eb_wide_alternation_end();
int eb_wide_character_text();
int eb_next_wide_appendix_character();
int eb_previous_wide_appendix_character();

#endif /* not __STDC__ */

#endif /* not EB_APPENDIX_H */
